require "util"
require "defines"

last_network = 0
networks = {}

function _init()
	remote.call("EvoGUI", "create_remote_sensor", { mod_name = "steinios_logistic_sensor",
													name = "steinio_ls1", 
													text = "Logistic bots: none", 
													caption = "Logistic bots" 
												}
	)
	remote.call("EvoGUI", "create_remote_sensor", { mod_name = "steinios_logistic_sensor",
													name = "steinio_ls2", 
													text = "Construction bots: none", 
													caption = "Construction bots" 
												}
	)
end

--Register a callback to be run on module init.
script.on_init( 
	function()
		_init()
	end
)

--Register a function to be run on module load.
script.on_load(
	function()
		_init()
	end
)

--It is fired once every tick. Since this event is fired every tick, its handler shouldn't include performance heavy code.
script.on_event(defines.events.on_tick, 
	function() 		
		if game.tick % 120 ~= 0 then return end
				
		local force = game.forces.player
		local logistic_networks = force.logistic_networks
		local amount = 0
		local text = ""
		
		for surface, surface_networks in pairs(logistic_networks) do
			for x, network in pairs(surface_networks) do 
				if network.valid then
					amount = x
					networks[x] = {
						surface = surface, 
						lbotsava = network.available_logistic_robots, 
						lbotsall = network.all_logistic_robots,
						cbotsava = network.available_construction_robots, 
						cbotsall = network.all_construction_robots 
					}
				end
			end
		end
				
		if amount > 0 then
			if last_network + 1 > amount then
				last_network = 1
			else
				last_network = last_network + 1
			end
			
			text1 = "Logistic bots: [#" .. last_network .. "/" .. amount .. "] " .. networks[last_network].lbotsava .. "/" .. networks[last_network].lbotsall
			text2 = "Construction bots: [#" .. last_network .. "/" .. amount .. "] " .. networks[last_network].cbotsava .. "/" .. networks[last_network].cbotsall
		else
			text1 = "Logistic bots: none"
			text2 = "Construction bots: none"
		end		
					
		remote.call(
			"EvoGUI", 
			"update_remote_sensor", 
			"steinio_ls1", 
			text1
		)
		remote.call(
			"EvoGUI", 
			"update_remote_sensor", 
			"steinio_ls2", 
			text2
		)
	end
)

function roundToNthDecimal(num, n)
	local mult = 10^(n or 0)
	return math.floor(num * mult + 0.5) / mult
end